package infomat.algorithms.reduction;

import infomat.vectorspace.*;
import infomat.vectorspace.similarity.*;
import infomat.vectorspace.vector.*;

import java.util.*;


public class Reducer{

    private static float minSim=0.0f;

    public IObjectGroup reduceGroup(IObjectGroup group, SparseISimilarity similarity, IVector<IVectorIndex> vec){
	
	IObjectGroup ret = new IObjectGroup("Reduced "+group.getName());
	Vector<IObject> ordered = group.getOrdered();
	for(int i=0; i<ordered.size(); i++){
	    IObject io = ordered.get(i);
	    IVector<IVectorIndex> repr = similarity.getRepresentation(io);
	    float sim = similarity.sim(repr, vec);
	    if(sim>minSim)
		ret.add(io, sim); //repr.getValue(io));
	}
	return ret;
    }


}
