package infomat.mro;

import infomat.algorithms.grouping.*;
import infomat.bridges.tct.algorithms.grouping.*;
import infomat.algorithms.labeling.*;
import infomat.evaluation.*;
import infomat.io.*;
import infomat.vectorspace.*;

import mro.util.*;
import mro.util.properties.*;
import mro.util.measures.*;

import java.io.*;
import java.util.HashMap;
import java.util.Vector;
import java.util.Arrays;

import org.xml.sax.SAXException;


/****************/

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/results/Repeat10WordsJtteliten/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat10WordsJtteliten/" 

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/results/Repeat10WordsA1/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat10WordsA1/" 

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/results/Repeat5WordsA1/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat5WordsA1/" 

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/results/Repeat20nTest5Words/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat20nTest5Words/" 

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080329/results/Repeat20nTest10Words/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat20nTest10Words/" 

// java -cp .:classes/:lib/tct-core.jar:lib/tct-matrix.jar:lib/tct-text.jar -Xms1024m -Xmx1024m infomat.ExperimentResultGenerator -resultPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/ClusterDescriptionExperiments080402/results/Repeat20nTest10WordsAllClusters/" -generationPath "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/avg/Repeat20nTest10WordsAllClusters/" 




/**
 *
 * NOT WORKING IN VERSION 080828
 *
 * Class for summing up an experiment.
 *
 * <br>
 * <br>
 * <code>java -cp .:classes/ -Xms3024m -Xmx3024m infomat.ExperimentResultGenerator</code>
 *
 * @version          080328
 * @author           Magnus Rosell
 *
 */
public class ExperimentResultGenerator implements HasProperties{


    InfoPool infoPool = new InfoPool();


    private PropertiesPool pp = new PropertiesPool();

    private Properties properties = null;


    public ExperimentResultGenerator(){
	this.properties = getDefaultProperties();
    }


    public Properties getDefaultProperties(){

	Properties properties = 
	    new Properties("Experiment Result Generator Properties", CurrentClassGetter.getClassName());
		
	try{
			
	    /****************/
	    Property p = new Property("Result Path", null, "Result Path");
	    properties.addProperty(p);

	    p = new Property("Generation Path", null, "Generation Path");
	    properties.addProperty(p);

	}catch(PropertyNameConflictException pnce){
	    // Won't happen here
	}
	return properties;
    }

    public Object getPropertyValue(String name){
    	return properties.getPropertyValue(name);
    }
    public void setProperty(String name, Object value) throws PropertyNotFoundException{
    	properties.setProperty(name, value);
    }

    public mro.util.properties.Properties getProperties(){
    	return properties;
    }

    public void setProperties(mro.util.properties.Properties properties){
    	this.properties=properties;
    }




    public static void main(String[] args) 
	throws org.xml.sax.SAXException, IOException, 
	       PropertyNotFoundException, MeasureNameConflictException{

	/*
	File dir = new File("/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/generation/results/");
	String outFileName = "/afs/nada.kth.se/home/f/u1ya3frf/Code/tmp/generation/out.xml";
	Averagor averagor = new Averagor();
	averagor.readAndWrite(dir, outFileName);
	*/

	System.out.println("main()");
	ExperimentResultGenerator exp = new ExperimentResultGenerator();
	exp.doIt(args);
    }




    public void doIt(String[] args) 
	throws IOException, SAXException, PropertyNotFoundException, MeasureNameConflictException{

	System.out.println("doIt()");
	checkInput(args);

	System.out.println("doIt()");
	String generationPathName = (String) 
	    getPropertyValue("Generation Path");
	String resultPathName = (String) getPropertyValue("Result Path");
	File path = new File(resultPathName);
	doOneDirectory(path);
	recurseResultPath(path);

	makeLatexTableFile();

	writeAverageMeasuresFiles();

	System.out.println("doIt()");

    }


    /*
    // Repeat 3, 5 clusters

    private String[] rowTitles = 
    {"Clust", 
     "$\\Delta^{(x)}$", "$Sz(\\Delta^{(x)})$", 
     "$C^{(x)}$", "$Sz(C^{(x)})$", 
     "$CSz(\\Delta^{(x)})$"};
    private String[] columnTitles = {"3 clusters", "5 clusters"};
    private String[][] pathMatrix1 =
    {
	{"03clusters/Random/clustering", "05clusters/Random/clustering"},
	{"03clusters/Random/labelReducedClustering", "05clusters/Random/labelReducedClustering"},
	{"03clusters/Random/randomlyReducedToLabelClusteringSize", "05clusters/Random/randomlyReducedToLabelClusteringSize"},
	{"03clusters/Random/centroidLabelReducedClustering", "05clusters/Random/centroidLabelReducedClustering"},
	{"03clusters/Random/randomlyReducedToCentroidClusteringSize", "05clusters/Random/randomlyReducedToCentroidClusteringSize"},
	{"03clusters/Random/sizeReducedClustering", "05clusters/Random/sizeReducedClustering"}
    };
 
    private String[][] pathMatrix2 = 
    {
	{"03clusters/KMeans/clustering", "05clusters/KMeans/clustering"},
	{"03clusters/KMeans/labelReducedClustering", "05clusters/KMeans/labelReducedClustering"},
	{"03clusters/KMeans/randomlyReducedToLabelClusteringSize", "05clusters/KMeans/randomlyReducedToLabelClusteringSize"},
	{"03clusters/KMeans/centroidLabelReducedClustering", "05clusters/KMeans/centroidLabelReducedClustering"},
	{"03clusters/KMeans/randomlyReducedToCentroidClusteringSize", "05clusters/KMeans/randomlyReducedToCentroidClusteringSize"},
	{"03clusters/KMeans/sizeReducedClustering", "05clusters/KMeans/sizeReducedClustering"}
    };

    private String[][] pathMatrix3 = 
    {
	{"03clusters/Bisect/clustering", "05clusters/Bisect/clustering"},
	{"03clusters/Bisect/labelReducedClustering", "05clusters/Bisect/labelReducedClustering"},
	{"03clusters/Bisect/randomlyReducedToLabelClusteringSize", "05clusters/Bisect/randomlyReducedToLabelClusteringSize"},
	{"03clusters/Bisect/centroidLabelReducedClustering", "05clusters/Bisect/centroidLabelReducedClustering"},
	{"03clusters/Bisect/randomlyReducedToCentroidClusteringSize", "05clusters/Bisect/randomlyReducedToCentroidClusteringSize"},
	{"03clusters/Bisect/sizeReducedClustering", "05clusters/Bisect/sizeReducedClustering"}
    };
    */



    // Repeat 10, 20, 40, 80 clusters

    private String[] rowTitles = 
    {
	"$\\Gamma$", 

	"$Centr^{(x)}$", 
	"$Sz(Centr^{(x)})$", 
	"$RSz(Centr^{(x)})$", 

	"$CLW^{(x)}$", 
	"$Sz(CLW^{(x)})$", 
	"$RSz(CLW^{(x)})$", 

	"$WLW^{(x)}$", 
	"$Sz(WLW^{(x)})$", 
	"$RSz(WLW^{(x)})$"

    };
    private String[] columnTitles = {"10 clusters", "20 clusters", "40 clusters", "80 clusters"};
    private String[][] pathMatrix1 =
    {
	{"10clusters/Random/clustering", "20clusters/Random/clustering", "40clusters/Random/clustering", "80clusters/Random/clustering"},

	{"10clusters/Random/centroidLabelReducedClustering", "20clusters/Random/centroidLabelReducedClustering", "40clusters/Random/centroidLabelReducedClustering", "80clusters/Random/centroidLabelReducedClustering"},
	{"10clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "20clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "40clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "80clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering"},
	{"10clusters/Random/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "20clusters/Random/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "40clusters/Random/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "80clusters/Random/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering"},

	{"10clusters/Random/centroidRankingLabelReducedClustering", "20clusters/Random/centroidRankingLabelReducedClustering", "40clusters/Random/centroidRankingLabelReducedClustering", "80clusters/Random/centroidRankingLabelReducedClustering"},
	{"10clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "20clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "40clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "80clusters/Random/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering"},
	{"10clusters/Random/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "20clusters/Random/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "40clusters/Random/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "80clusters/Random/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering"},

	{"10clusters/Random/weightRankingLabelReducedClustering", "20clusters/Random/weightRankingLabelReducedClustering", "40clusters/Random/weightRankingLabelReducedClustering", "80clusters/Random/weightRankingLabelReducedClustering"},
	{"10clusters/Random/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "20clusters/Random/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "40clusters/Random/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "80clusters/Random/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering"},
	{"10clusters/Random/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "20clusters/Random/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "40clusters/Random/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "80clusters/Random/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering"}
    };
 
    private String[][] pathMatrix2 = 
    {

	{"10clusters/KMeans/clustering", "20clusters/KMeans/clustering", "40clusters/KMeans/clustering", "80clusters/KMeans/clustering"},

	{"10clusters/KMeans/centroidLabelReducedClustering", "20clusters/KMeans/centroidLabelReducedClustering", "40clusters/KMeans/centroidLabelReducedClustering", "80clusters/KMeans/centroidLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "20clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "40clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "80clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "20clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "40clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "80clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering"},

	{"10clusters/KMeans/centroidRankingLabelReducedClustering", "20clusters/KMeans/centroidRankingLabelReducedClustering", "40clusters/KMeans/centroidRankingLabelReducedClustering", "80clusters/KMeans/centroidRankingLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "20clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "40clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "80clusters/KMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "20clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "40clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "80clusters/KMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering"},

	{"10clusters/KMeans/weightRankingLabelReducedClustering", "20clusters/KMeans/weightRankingLabelReducedClustering", "40clusters/KMeans/weightRankingLabelReducedClustering", "80clusters/KMeans/weightRankingLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "20clusters/KMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "40clusters/KMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "80clusters/KMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering"},
	{"10clusters/KMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "20clusters/KMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "40clusters/KMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "80clusters/KMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering"}


    };

    private String[][] pathMatrix3 = 
    {
	{"10clusters/TCTKMeans/clustering", "20clusters/TCTKMeans/clustering", "40clusters/TCTKMeans/clustering", "80clusters/TCTKMeans/clustering"},

	{"10clusters/TCTKMeans/centroidLabelReducedClustering", "20clusters/TCTKMeans/centroidLabelReducedClustering", "40clusters/TCTKMeans/centroidLabelReducedClustering", "80clusters/TCTKMeans/centroidLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering"},

	{"10clusters/TCTKMeans/centroidRankingLabelReducedClustering", "20clusters/TCTKMeans/centroidRankingLabelReducedClustering", "40clusters/TCTKMeans/centroidRankingLabelReducedClustering", "80clusters/TCTKMeans/centroidRankingLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering"},

	{"10clusters/TCTKMeans/weightRankingLabelReducedClustering", "20clusters/TCTKMeans/weightRankingLabelReducedClustering", "40clusters/TCTKMeans/weightRankingLabelReducedClustering", "80clusters/TCTKMeans/weightRankingLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering"},
	{"10clusters/TCTKMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "20clusters/TCTKMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "40clusters/TCTKMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "80clusters/TCTKMeans/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering"}
    };

    private String[][] pathMatrix4 = 
    {
	{"10clusters/Bisect/clustering", "20clusters/Bisect/clustering", "40clusters/Bisect/clustering", "80clusters/Bisect/clustering"},

	{"10clusters/Bisect/centroidLabelReducedClustering", "20clusters/Bisect/centroidLabelReducedClustering", "40clusters/Bisect/centroidLabelReducedClustering", "80clusters/Bisect/centroidLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "20clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "40clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering", "80clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "20clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "40clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering", "80clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidLabelReducedClustering"},

	{"10clusters/Bisect/centroidRankingLabelReducedClustering", "20clusters/Bisect/centroidRankingLabelReducedClustering", "40clusters/Bisect/centroidRankingLabelReducedClustering", "80clusters/Bisect/centroidRankingLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "20clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "40clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering", "80clusters/Bisect/sizeReducedCentroidOrderedToSizeOfcentroidRankingLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "20clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "40clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering", "80clusters/Bisect/sizeReducedRandomlyToSizeOfcentroidRankingLabelReducedClustering"},

	{"10clusters/Bisect/weightRankingLabelReducedClustering", "20clusters/Bisect/weightRankingLabelReducedClustering", "40clusters/Bisect/weightRankingLabelReducedClustering", "80clusters/Bisect/weightRankingLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "20clusters/Bisect/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "40clusters/Bisect/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering", "80clusters/Bisect/sizeReducedCentroidOrderedToSizeOfweightRankingLabelReducedClustering"},
	{"10clusters/Bisect/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "20clusters/Bisect/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "40clusters/Bisect/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering", "80clusters/Bisect/sizeReducedRandomlyToSizeOfweightRankingLabelReducedClustering"}
    };


    /*
    // Repeat 5, 10 clusters

    private String[] rowTitles = 
    {"Clust", 
     "$\\Delta^{(x)}$", "$Sz(\\Delta^{(x)})$", 
     "$C^{(x)}$", "$Sz(C^{(x)})$", 
     "$CSz(\\Delta^{(x)})$"};
    private String[] columnTitles = {"5 clusters", "10 clusters"};
    private String[][] pathMatrix1 =
    {
	{"10clusters/Random/clustering", "20clusters/Random/clustering"},
	{"10clusters/Random/labelReducedClustering", "20clusters/Random/labelReducedClustering"},
	{"10clusters/Random/randomlyReducedToLabelClusteringSize", "20clusters/Random/randomlyReducedToLabelClusteringSize"},
	{"10clusters/Random/centroidLabelReducedClustering", "20clusters/Random/centroidLabelReducedClustering"},
	{"10clusters/Random/randomlyReducedToCentroidClusteringSize", "20clusters/Random/randomlyReducedToCentroidClusteringSize"},
	{"10clusters/Random/sizeReducedClustering", "20clusters/Random/sizeReducedClustering"}
    };
 
    private String[][] pathMatrix2 = 
    {
	{"10clusters/KMeans/clustering", "20clusters/KMeans/clustering"},
	{"10clusters/KMeans/labelReducedClustering", "20clusters/KMeans/labelReducedClustering"},
	{"10clusters/KMeans/randomlyReducedToLabelClusteringSize", "20clusters/KMeans/randomlyReducedToLabelClusteringSize"},
	{"10clusters/KMeans/centroidLabelReducedClustering", "20clusters/KMeans/centroidLabelReducedClustering"},
	{"10clusters/KMeans/randomlyReducedToCentroidClusteringSize", "20clusters/KMeans/randomlyReducedToCentroidClusteringSize"},
	{"10clusters/KMeans/sizeReducedClustering", "20clusters/KMeans/sizeReducedClustering"}
    };

    private String[][] pathMatrix3 = 
    {
	{"10clusters/Bisect/clustering", "20clusters/Bisect/clustering"},
	{"10clusters/Bisect/labelReducedClustering", "20clusters/Bisect/labelReducedClustering"},
	{"10clusters/Bisect/randomlyReducedToLabelClusteringSize", "20clusters/Bisect/randomlyReducedToLabelClusteringSize"},
	{"10clusters/Bisect/centroidLabelReducedClustering", "20clusters/Bisect/centroidLabelReducedClustering"},
	{"10clusters/Bisect/randomlyReducedToCentroidClusteringSize", "20clusters/Bisect/randomlyReducedToCentroidClusteringSize"},
	{"10clusters/Bisect/sizeReducedClustering", "20clusters/Bisect/sizeReducedClustering"}
    };


    */

    private Measure[][] makeEntropyMatrix(String[][] pathMatrix){
	Measure[][] measureMatrix = 
	    new Measure[pathMatrix.length][pathMatrix[0].length];

	Vector<Info> infoVector = infoPool.getInfoVector();

	for(int i=0; i<infoVector.size(); i++){
	    Info info = infoVector.elementAt(i);
	    Measures ms = info.measures;
	    String pathString = infoPool.getPathForInfo(info);
	    for(int r=0; r<pathMatrix.length; r++){
		for(int c=0; c<pathMatrix[0].length; c++){
		    if(pathString.endsWith(pathMatrix[r][c])){
			System.out.println("Measures: "+pathMatrix[r][c]);
			System.out.println("Trying....");
			MeasureGroup mg = 
			    ms.getMeasureGroup("Extrinsic Measures");
			if(mg!=null){
			    System.out.println("Extrinsic Measures");
			    mg = mg.getMeasureGroup("Global Extrinsic Measures");
			    if(mg!=null){
				System.out.println("Global Extrinsic Measures");
				Measure m = mg.getMeasure("Entropy");
				if(m!=null){
				    AverageMeasure am = (AverageMeasure) m;
				    System.out.println("Entropy: "+am.getValue()+", "+am.getSTD());
				    measureMatrix[r][c]=m;
				}
			    }
			}
		    }
		}
	    }
	}
	return measureMatrix;
    }

    private Measure[][] makeNumberOfTextsMatrix(String[][] pathMatrix){
	Measure[][] measureMatrix = 
	    new Measure[pathMatrix.length][pathMatrix[0].length];

	Vector<Info> infoVector = infoPool.getInfoVector();

	for(int i=0; i<infoVector.size(); i++){
	    Info info = infoVector.elementAt(i);
	    Measures ms = info.measures;
	    String pathString = infoPool.getPathForInfo(info);
	    for(int r=0; r<pathMatrix.length; r++){
		for(int c=0; c<pathMatrix[0].length; c++){
		    if(pathString.endsWith(pathMatrix[r][c])){
			MeasureGroup mg = 
			    ms.getMeasureGroup("Intrinsic Measures");
			if(mg!=null){
			    mg = 
				mg.getMeasureGroup("Evaluated Grouping");
			    if(mg!=null){
				Measure m = mg.getMeasure("Number Of IObjects");
				if(m!=null){
				    measureMatrix[r][c]=m;
				}
			    }
			}
		    }
		}
	    }
	}
	return measureMatrix;
    }


    // groupingString: "Evaluated Grouping", "Reference Grouping"
    private Measure[][] makeNumberOfClustersMatrix(String[][] pathMatrix, String groupingString){
	Measure[][] measureMatrix = 
	    new Measure[pathMatrix.length][pathMatrix[0].length];

	Vector<Info> infoVector = infoPool.getInfoVector();

	for(int i=0; i<infoVector.size(); i++){
	    Info info = infoVector.elementAt(i);
	    Measures ms = info.measures;
	    String pathString = infoPool.getPathForInfo(info);
	    for(int r=0; r<pathMatrix.length; r++){
		for(int c=0; c<pathMatrix[0].length; c++){
		    if(pathString.endsWith(pathMatrix[r][c])){
			MeasureGroup mg = 
			    ms.getMeasureGroup("Intrinsic Measures");
			if(mg!=null){
			    mg = 
				mg.getMeasureGroup(groupingString);
			    if(mg!=null){
				Measure m = mg.getMeasure("Number Of IObjectGroups");
				if(m!=null){
				    measureMatrix[r][c]=m;
				}
			    }
			}
		    }
		}
	    }
	}
	return measureMatrix;
    }



    private void 
	makeMatrixNormalizedDifferenceOnRowNr(Measure[][] measureMatrix, 
					      int rowNr){

	Measure[] rowNormal = new Measure[measureMatrix[0].length];
	for(int c=0; c<measureMatrix[0].length; c++){
	    rowNormal[c] = measureMatrix[rowNr][c];
	}

	for(int r=0; r<measureMatrix.length; r++){
	    for(int c=0; c<measureMatrix[0].length; c++){
		AverageMeasure am = (AverageMeasure) measureMatrix[r][c];
		AverageMeasure norm = (AverageMeasure) rowNormal[c];
		System.out.println("---------");
		System.out.println(am);
		System.out.println(norm);
		measureMatrix[r][c] = (Measure) am.normDifference(norm);
	    }
	}
	
    }


    private void makeLatexTableFile() throws IOException{

	String generationPathName = (String) 
	    getPropertyValue("Generation Path") + File.separator;

	File path = new File(generationPathName);
	if(!path.exists())
	    path.mkdirs();
	

	String latexFileName = generationPathName+"avg.tex";
	PrintWriter pw = new PrintWriter(new BufferedWriter(new FileWriter(latexFileName)));



	LatexHelper.printLatexHead(pw);
	Vector<String> columnTitlesVector = 
	    new Vector<String>(Arrays.asList(columnTitles));
	int numberOfColumns = 30;
	boolean rowTitlesOn = true;
	//	LatexHelper.printTableHead(pw, columnTitlesVector, rowTitlesOn);
	LatexHelper.printTableHead(pw, numberOfColumns);//, rowTitlesOn);

	Vector<String[][]> pathMatrixes = new Vector<String[][]>();
	pathMatrixes.add(pathMatrix1);
	pathMatrixes.add(pathMatrix2);
	pathMatrixes.add(pathMatrix3);
	pathMatrixes.add(pathMatrix4);

	for(int i=0; i<pathMatrixes.size(); i++){
	    int rowNr = 0;
	    String[][] pathMatrix = pathMatrixes.elementAt(i);
	    /*
	    Measure[][] measureMatrix = makeEntropyMatrix(pathMatrix);
	    //	    makeMatrixNormalizedDifferenceOnRowNr(measureMatrix, rowNr);
	    printMeasureMatrixIntoLatexTable(pw, rowTitles, measureMatrix);
	    */

	    Measure[][] entropyMatrix = makeEntropyMatrix(pathMatrix);

	    Measure[][] relEntropyMatrix = makeEntropyMatrix(pathMatrix);
	    makeMatrixNormalizedDifferenceOnRowNr(relEntropyMatrix, rowNr);

	    Measure[][] textsMatrix = makeNumberOfTextsMatrix(pathMatrix);

	    String groupingString = "Evaluated Grouping";
	    Measure[][] evalClustersMatrix = makeNumberOfClustersMatrix(pathMatrix, groupingString);
	    groupingString = "Reference Grouping";
	    Measure[][] refCategoriesMatrix = makeNumberOfClustersMatrix(pathMatrix, groupingString);



	    printSpecialIntoLatexTable(pw, rowTitles, entropyMatrix, relEntropyMatrix, textsMatrix, evalClustersMatrix, refCategoriesMatrix);

	    if(i<pathMatrixes.size()-1)
		LatexHelper.printHLine(pw);
	}

	String caption="Table";
	String label="Table";
	LatexHelper.printTableEnd(pw, caption, label);
	//	LatexHelper.printTableEnd(pw);
	LatexHelper.printLatexEnd(pw);
	pw.close();

	System.out.println("Latex file name: "+latexFileName);
    }

    private void 
	printSpecialIntoLatexTable(PrintWriter pw, 
				   String[] rowTitles, 
				   Measure[][] absMeasureMatrix,
				   Measure[][] relMeasureMatrix,
				   Measure[][] absMeasureMatrix2,
				   Measure[][] absMeasureMatrix3,
				   Measure[][] absMeasureMatrix4) 
	throws IOException{

	for(int r=0; r<absMeasureMatrix.length; r++){
	    Vector<String> rowStrings = new Vector<String>();
	    rowStrings.add(rowTitles[r]);
	    for(int c=0; c<absMeasureMatrix[0].length; c++){

		//////////////
		Measure m = absMeasureMatrix[r][c];
		AverageMeasure am = (AverageMeasure) m;
		String val = Round.roundDecimalsToTrimmedString(am.getValue(), 2);
		String std = Round.roundDecimalsToTrimmedString(am.getSTD(), 2);
		rowStrings.add("$"+val+" \\  ("+std+")$"); 

		//////////////
		m = relMeasureMatrix[r][c];
		am = (AverageMeasure) m;
		val = Round.roundDecimalsToTrimmedString(am.getValue(), 2);
		std = Round.roundDecimalsToTrimmedString(am.getSTD(), 2);
		rowStrings.add("$"+val+" \\  ("+std+")$"); 

		//////////////
		m = absMeasureMatrix2[r][c];
		am = (AverageMeasure) m;
		int valInt = (int) Math.round(am.getValue());
		int stdInt = (int) Math.round(am.getSTD());
		rowStrings.add("$"+valInt+" \\  ("+stdInt+")$"); 

		/*
		//////////////
		m = absMeasureMatrix3[r][c];
		am = (AverageMeasure) m;
		valInt = (int) Math.round(am.getValue());
		stdInt = (int) Math.round(am.getSTD());
		rowStrings.add("$"+valInt+" \\  ("+stdInt+")$"); 

		//////////////
		m = absMeasureMatrix4[r][c];
		am = (AverageMeasure) m;
		valInt = (int) Math.round(am.getValue());
		stdInt = (int) Math.round(am.getSTD());
		rowStrings.add("$"+valInt+" \\  ("+stdInt+")$"); 
		*/
	    }
	    LatexHelper.printTableRow(pw, rowStrings);
	}
    }

    private void 
	printMeasureMatrixIntoLatexTable(PrintWriter pw, 
					 String[] rowTitles, 
					 Measure[][] measureMatrix) 
	throws IOException{

	for(int r=0; r<measureMatrix.length; r++){
	    Vector<String> rowStrings = new Vector<String>();
	    rowStrings.add(rowTitles[r]);
	    for(int c=0; c<measureMatrix[0].length; c++){
		Measure m = measureMatrix[r][c];
		if(m!=null){
		    AverageMeasure am = (AverageMeasure) m;
		    String val = Round.roundDecimalsToTrimmedString(am.getValue(), 2);
		    String std = Round.roundDecimalsToTrimmedString(am.getSTD(), 2);
		    rowStrings.add("$"+val+" \\  ("+std+")$"); 
		}
	    }
	    LatexHelper.printTableRow(pw, rowStrings);
	}
    }

    /*
    private void 
	printMeasuresMatrixIntoLatexTable(PrintWriter pw, 
					  String[] rowTitles, 
					  Measures[][] measuresMatrix) 
	throws IOException{

	for(int r=0; r<measuresMatrix.length; r++){
	    Vector<String> rowStrings = new Vector<String>();
	    rowStrings.add(rowTitles[r]);
	    for(int c=0; c<measuresMatrix[0].length; c++){
		Measures ms = measuresMatrix[r][c];
		MeasureGroup mg = ms.getMeasureGroup("Extrinsic Measures");
		if(mg!=null){
		    Measure m = mg.getMeasure("Entropy");
		    if(m!=null){
			AverageMeasure am = (AverageMeasure) m;
			String val = Round.roundDecimalsToTrimmedString(am.getValue(), 2);
			String std = Round.roundDecimalsToTrimmedString(am.getSTD(), 2);
			rowStrings.add("$"+val+" \\  ("+std+")$"); 
			//			rowStrings.add("$"+am.getValue()+" ("+am.getSTD()+")$"); 
		    }
		}
	    }
	    LatexHelper.printTableRow(pw, rowStrings);
	}
    }
    */


    /*
    private boolean processDir(String pathName){
	String[] ss = pathName.split("["+File.separator+"]");
	for(int i=0; i<ss.length; i++){
	    if(ss[i].compareTo("40clusters")==0)
		return false;
	}
	return true;
    }
    */

    private void recurseResultPath(File path) 
	throws IOException, SAXException, MeasureNameConflictException{
	if(!path.isDirectory())
	    badInput("Specified \"Result Path\" not a path!");

	//	if(!processDir(path.getPath()))
	//	    return;


	System.out.println("resurseResultPath()");

	File[] list = path.listFiles();
	for(int i=0; i<list.length; i++){
	    //	    System.out.println(list[i].getPath());
	    if(list[i].isDirectory()){

		//		if(!processDir(list[i].getPath()))
		//		    continue;

		doOneDirectory(list[i]);
		recurseResultPath(list[i]);
	    }
	}
    }


    private void doOneDirectory(File dir) throws IOException, SAXException, MeasureNameConflictException{
	System.out.println("doOneDirectory(): "+dir.getPath());

	String generationPathName =  
	    (String) getPropertyValue("Generation Path");

	String outFileName = generationPathName+File.separator+System.currentTimeMillis()+".xml";

	Averagor averagor = new Averagor();
	Measures measures = averagor.readAllMeasuresInDirectory(dir);
	PropertiesPool pp = new PropertiesPool();
	pp.loadPropertiesInDirectory(dir);

	infoPool.addInfo(dir, measures, pp);

	//	averagor.readAndWrite(dir, outFileName);
    }


    public void writeAverageMeasuresFiles() throws IOException{
	String resultPathName = (String) getPropertyValue("Result Path");
	File resultPath = new File(resultPathName);

	String generationPathName = 
	    (String) getPropertyValue("Generation Path");
	File generationPath = new File(generationPathName);

	Vector<Info> infoVector = infoPool.getInfoVector();
	for(int i=0; i<infoVector.size(); i++){
	    Info info = infoVector.elementAt(i);
	    Measures ms = info.measures;
	    PropertiesPool pp = info.pp;

	    String infoPath = infoPool.getPathForInfo(info) + File.separator;
	    System.out.println(" * "+infoPath);
	    String outInfoPath = null;
	    if(infoPath.equals(resultPathName))
		outInfoPath = generationPathName + File.separator;
	    else
		outInfoPath = generationPathName + infoPath.substring(resultPathName.length(), infoPath.length());

	    System.out.println(" - "+outInfoPath);

	    File path = new File(outInfoPath);
	    if(!path.exists())
		path.mkdirs();

	    if(ms!=null)
		ms.save(outInfoPath+File.separator+"average.xml");
	    if(pp!=null)
		pp.savePropertiesToDirectory(outInfoPath+File.separator);
	}

    }



    private void badInput(String comment){
	System.out.println("Bad input!");
	System.out.println(comment);
	System.exit(0);
    }

    
    private void checkInput(String[] args) throws IOException, SAXException, PropertyNotFoundException{

	if(args.length==0)
	    badInput("To few arguments.");



	for(int i=0; i<args.length; i++){
	    if(args[i].equals("-resultPath")){
		setProperty("Result Path", args[i+1]);
	    }
	    else if(args[i].equals("-generationPath")){
		setProperty("Generation Path", args[i+1]);
	    }
	}
	    
    }


    /**
     * Private class for storing info for each directory.
     */
    private class Info{
	public Measures measures;
	public PropertiesPool pp;
	
	public Info(Measures measures, PropertiesPool pp){
		this.measures=measures;
		this.pp=pp;
	}
    }

    /**
     * Private class for storing info for each directory.
     */
    private class InfoPool{

	private Vector<Info> infoVector = new Vector<Info>();

	private HashMap<String, Info> pathInfoMap = 
	    new HashMap<String, Info>();
	
	private HashMap<Info, String> infoPathMap = 
	    new HashMap<Info, String>();

	public void addInfo(File dir, Measures measures, PropertiesPool pp){
	    Vector<Measure> vec = measures.getMeasureVector();
	    
	    if(vec.size()==0)
		measures=null;
	    if(pp.size()==0)
		pp=null;
	    if(measures!=null || pp!=null){
		Info info = new Info(measures, pp);
		infoVector.add(info);
		pathInfoMap.put(dir.getPath(), info);
		infoPathMap.put(info, dir.getPath());
	    }
	}

	public Measures getMeasuresForPath(String pathName){
	    Info info = pathInfoMap.get(pathName);
	    if(info==null)
		return null;
	    return info.measures;
	}

	public PropertiesPool getPropertiesPoolForPath(String pathName){
	    Info info = pathInfoMap.get(pathName);
	    if(info==null)
		return null;
	    return info.pp;
	}

	public String getPathForInfo(Info info){
	    return infoPathMap.get(info);
	}

	public Vector<Info> getInfoVector(){
	    return infoVector;
	}

    }


}
