package infomat.vectorspace;

import java.util.*;


/**
 * A IObjectGroupNode is a node in a HierarchicalIObjectGrouping.
 *
 * @version          080304
 * @author           Magnus Rosell
 */
public class IObjectGroupNode{

    private IObjectGroup ioGroup = null;
    private IObjectGroupNode parent = null;
    private Vector<IObjectGroupNode> children = null;

    public IObjectGroupNode(IObjectGroup iog, IObjectGroupNode parent){
	ioGroup = iog;
	this.parent = parent;
    }

    public void addChild(IObjectGroupNode node){
	if(children==null)
	    children = new Vector<IObjectGroupNode>();
	children.add(node);
    }

    public void addChild(IObjectGroup iog){
	if(children==null)
	    children = new Vector<IObjectGroupNode>();
	IObjectGroupNode node = new IObjectGroupNode(iog, this);
	children.add(node);
    }

    public void addGroupsAsChildren(IObjectGrouping ioging){
	Vector<IObjectGroup> groups = ioging.getGroups();
	for(int i=0; i<groups.size(); i++){
	    addChild(groups.elementAt(i));
	}
    }

    public IObjectGroupNode getParent(){
	return parent;
    }

    /*
    public IObjectGroup getParentGroup(){
	return parent.getIOBjectGroup();
    }
    */
    
    public IObjectGroup getIObjectGroup(){
	return ioGroup;
    }
    
    public Vector<IObjectGroupNode> getChildren(){
	return children;
    }
    

}

