package infomat.vectorspace.similarity;

import infomat.vectorspace.*;

import mro.util.properties.*;

import java.util.HashMap;

/**
 * Similarity Measure.
 *
 * @version          080403
 * @author           Magnus Rosell
 */
public abstract class ISimilarity implements HasProperties{

    protected Properties properties;

    public ISimilarity(){
	this.properties = getDefaultProperties();	
    }

    public abstract float sim(IObject io1, IObject io2);

    public abstract float sim(IObject io, IObjectGroup iog);

    public abstract float sim(IObjectGroup iog1, IObjectGroup iog2);

    public abstract String getName();

}
