package infomat.view;

import infomat.view.util.*;

import mro.util.CurrentClassGetter;
import mro.util.properties.*;
import mro.util.properties.dialog.*;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;

public class InfomatPropertiesFrame 
    extends JFrame implements ActionListener{

    private InfomatModel model;
    private JPanel allPanel;
    private SmallButton apply;
    private SmallButton cancel;

    public static Dimension PROPERTIESFRAME_PREFERRED_SIZE = 
	new Dimension(300, 500);
    
    public InfomatPropertiesFrame(InfomatModel model){
	super(model.getProperties().getPropertiesName());
	this.model=model;
	Container container = getContentPane();
	allPanel = new JPanel();
	allPanel.setLayout(new BoxLayout(allPanel, BoxLayout.Y_AXIS));
	putAll();

	container.add(allPanel);
	
	setVisible(true);
	setPreferredSize(PROPERTIESFRAME_PREFERRED_SIZE);
	pack();
    }
	

    public void putAll(){
	allPanel.removeAll();

	JPanel buttonPanel = new JPanel();
	buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.X_AXIS));
	apply = new SmallButton("Apply");
	//	apply.setPreferredSize(buttonSize);
	apply.addActionListener(this);
	buttonPanel.add(apply);
	cancel = new SmallButton("Cancel");
	//	cancel.setPreferredSize(buttonSize);
	cancel.addActionListener(this);
	buttonPanel.add(cancel);
	
	allPanel.add(buttonPanel);
	buttonPanel.setAlignmentX(LEFT_ALIGNMENT);

	String path = (String) model.getPropertyValue("Result Path");
	allPanel.add(new PropertiesPanel(model, path));

	repaint();
    }

    public void actionPerformed(ActionEvent e) {
	if(e.getSource() instanceof JButton){
	    JButton source = (JButton) e.getSource();
	    if(source == apply){
		model.alteredProperties();
	    }else if(source == cancel){
		setVisible(false);
	    }
	}			
	
    }


	
}

