package infomat.view.info;

import infomat.view.*;
import infomat.view.picture.*;
import infomat.vectorspace.*;

import java.awt.*;

import javax.swing.*;

public class PixelInfoFrame extends JFrame{

	private boolean visible=true;
	private Container container;
	private JPanel containerPanel;
	
	private InfomatModel model;
	private InfomatView view;
	private DimensionInfoPanel rowPanel;
	private DimensionInfoPanel colPanel;
	
	private PixelInfoPanel pixelInfoPanel;
	
	private boolean hold=false;
	
	public static final Dimension PIXELINFOFRAME_PREFERRED_SIZE = 
		new Dimension(300, 400);

	public PixelInfoFrame(String title, InfomatModel model, InfomatView view){
		super(title);
		this.model=model;
		this.view=view;

		setPreferredSize(PIXELINFOFRAME_PREFERRED_SIZE);
		container = getContentPane();
		container.setLayout(new GridLayout(1,1));
		containerPanel = new JPanel();
		containerPanel.setPreferredSize(PIXELINFOFRAME_PREFERRED_SIZE);
		containerPanel.setLayout(new BoxLayout(containerPanel, BoxLayout.Y_AXIS));
		container.add(containerPanel);
		
		//container.setLayout(new GridLayout(3,1));
		//container.setLayout(new FlowLayout());
		//setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		Dimension dimInfoPanelPreferredSize = 
			new Dimension(PIXELINFOFRAME_PREFERRED_SIZE.width, 
					DimensionInfoPanel.DIMENSIONINFOPANLE_PREFERRED_HEIGHT);
		
		boolean row=true;
		rowPanel = new DimensionInfoPanel(model, view, row);
		rowPanel.setPreferredSize(dimInfoPanelPreferredSize);
		rowPanel.setMinimumSize(dimInfoPanelPreferredSize);
		rowPanel.setMaximumSize(dimInfoPanelPreferredSize);
		rowPanel.setLayout(new BoxLayout(rowPanel, BoxLayout.Y_AXIS));
		row=false;
		colPanel = new DimensionInfoPanel(model, view, row);
		colPanel.setPreferredSize(dimInfoPanelPreferredSize);
		colPanel.setMinimumSize(dimInfoPanelPreferredSize);
		colPanel.setMaximumSize(dimInfoPanelPreferredSize);
		colPanel.setLayout(new BoxLayout(colPanel, BoxLayout.Y_AXIS));

		pixelInfoPanel = new PixelInfoPanel(model, view);

		/*
		Dimension d = container.getSize();
		rowPanel.setPreferredSize(d);
		rowPanel.setMinimumSize(d);
		rowPanel.setMaximumSize(d);			
		colPanel.setPreferredSize(d);
		colPanel.setMinimumSize(d);
		colPanel.setMaximumSize(d);			
		 */
		
		putAll();
	}
	
	public void putAll(){
		if(visible){
			/*
			Dimension d = new Dimension((int) container.getSize().width, 
					DimensionInfoPanel.DIMENSIONINFOPANLE_PREFERRED_HEIGHT);
			 */
			containerPanel.removeAll();
			
			/*
			rowPanel.setPreferredSize(d);
			rowPanel.setMinimumSize(d);
			rowPanel.setMaximumSize(d);			
			colPanel.setPreferredSize(d);
			colPanel.setMinimumSize(d);
			colPanel.setMaximumSize(d);			
			*/
			
			containerPanel.add(rowPanel);
			containerPanel.add(colPanel);
			//sparsePicture.setSize(getSize());
	
			containerPanel.add(pixelInfoPanel);
			
			/*
			Dimension d = containerPanel.getPreferredSize();
			rowPanel.setPreferredSize(d);
			rowPanel.setMinimumSize(d);
			rowPanel.setMaximumSize(d);			
			colPanel.setPreferredSize(d);
			colPanel.setMinimumSize(d);
			colPanel.setMaximumSize(d);			
			*/
			
			
			pack();
		}
	}
	
	public void setCurrentInfo(IObject rowObject, IObject colObject){
		if(visible && !hold){
			//IMatrix matrix = model.getIMatrix();
			rowPanel.setCurrentInfo(rowObject);
			colPanel.setCurrentInfo(colObject);
			pixelInfoPanel.setCurrentInfo(rowObject, colObject);
		}
	}
	
	public void setHoldPixel(IObject rowObject, IObject colObject){
		//IMatrix matrix = model.getIMatrix();
		rowPanel.setCurrentInfo(rowObject);
		colPanel.setCurrentInfo(colObject);
		pixelInfoPanel.setCurrentInfo(rowObject, colObject);
	}
	
	public void setVisible(boolean visible){
		super.setVisible(visible);
		this.visible=visible;
	}

	public boolean getVisible(){
		return visible;
	}
	
	public void hold(){
		hold=true;
	}
	
	public void unHold(){
		hold=false;
	}

	/*
	public void setShowAllPixels(){
		pixelInfoPanel.setShowAllPixels();
	}
	 */
	
	/*	
	public void paintComponent(Graphics g){
		container.paintComponent(g);
	}
	*/

}
