package mro.util.measures;

import mro.util.*;

import infomat.vectorspace.IObjectGroup;

import java.io.*;
import java.util.*; 

/**
 * A multi measure:
 * Several values. For instance used for "Part purity".
 *
 * @version          061127
 * @author           Magnus Rosell
 */

public class MultiMeasure extends Measure{

	Vector<Measure> measures = new Vector<Measure>();
	
	public MultiMeasure(){}

	public MultiMeasure(String name, double value, String description){
		super(name, value, description);
	}


	/**
	 * Copy Constructor.
	 */
	public MultiMeasure(MultiMeasure p2){
		super(p2);
	}


	/**
	 * To read from XML files...
	 */
/*
	public MultiMeasure(String name, String value, 
			String MultiMeasureDescription){
		double o=0.0;

		try{o = (Double) Double.parseDouble(value);}
		catch(Exception e2){
			System.out.println("Problem: MultiMeasure: not a double!");
			System.exit(0);
		}


		this.name=name;
		this.value=o;
		this.MultiMeasureDescription=MultiMeasureDescription;
	}
	*/
	
	public MultiMeasure(String name, double value, String description, IObjectGroup iogrelative){
		super(name, value, description, iogrelative);
	}
	

	public void addMeasure(Measure m){
		measures.add(m);
	}
	
	public Vector<Measure> getMeasures(){
		return measures;
	}
	
	public void printXML(PrintWriter pw) throws IOException{
		pw.println("<mm>");
		pw.print("<n>"+getName()+"</n>");
		pw.println("<v>"+getValue()+"</v>");
		pw.println("<d>"+getDescription()+"</d>");
		pw.println("<stamp>"+getStamp()+"</stamp>");
		for(int i = 0; i < measures.size(); i++){
			measures.get(i).printXML(pw);
		}
		pw.println("</mm>");
	}
	
	
	
}
